(function ($, Drupal) {
  Drupal.behaviors.dynamicColumnsBehavior = {
    attach: function (context, settings) {

      function structureColumnElement(element){

        var xsColumnCount = $(element).attr('data-xs-column-count');
        var xsBreakPoint = $(element).attr('data-xs-break-point');
        var sColumnCount = $(element).attr('data-s-column-count');
        var sBreakPoint = $(element).attr('data-s-break-point');
        var mColumnCount = $(element).attr('data-m-column-count');
        var mBreakPoint = $(element).attr('data-m-break-point');
        var lColumnCount = $(element).attr('data-l-column-count');
        var lBreakPoint = $(element).attr('data-l-break-point');
        var xlColumnCount = $(element).attr('data-xl-column-count');
        var xlBreakPoint = $(element).attr('data-xl-break-point');
        var screenWidth = document.body.clientWidth;
        var columnWidth = '100%';
        var columnCount = 1;

        if (screenWidth <= xsBreakPoint) {
          columnWidth = 'calc(100% /' + xsColumnCount + ')';
          columnCount = xsColumnCount;
        }
        else if (screenWidth <= sBreakPoint) {
          columnWidth = 'calc(100% /' + sColumnCount + ')';
          columnCount = sColumnCount;
        }
        else if (screenWidth <= mBreakPoint) {
          columnWidth = 'calc(100% /' + mColumnCount + ')';
          columnCount = mColumnCount;
        }
        else if (screenWidth <= lBreakPoint) {
          columnWidth = 'calc(100% /' + lColumnCount + ')';
          columnCount = lColumnCount;
        } else {
          columnWidth = 'calc(100% /' + xlColumnCount + ')';
          columnCount = xlColumnCount;
        }

        $(element).children('li').css({'width': columnWidth, 'clear': 'none'});
        $(element).children('li:nth-child(' + columnCount + 'n+1)').css({'clear': 'left'});

      }

      function structureColumnElements(){
        $(context).find('.responsive-columns').each(function () {
          var element = $(this);
          structureColumnElement(element);
        });
      }

      structureColumnElements();

      $(window).resize(function(){
        structureColumnElements();
      });

    }
  };
})(jQuery, Drupal);
